module XMLAlgebra where
import XMLLex
import XMLGram

type XMLAlgebra node tag attr
  = (  ( String -> [String] -> String    -> String
       , String                          -> String
       , String -> [String]              -> String
       )
    ,  ( String -> [Attribute]           -> String
       , String                          -> String
       , String -> [Attribute]           -> String
       )
    ,  ( String -> String -> String      -> String
       )
    )

foldXML :: Node -> String
foldXML = fNode 0
 where fNode l (Node o c@([Content _]) s) = fTag l o ++ (concat $ map (fNode (l+1)) c) ++ fTag l s
       fNode l (Node o c s)               = fTag l o ++ (concat $ map ((indent (l+1) ++).(fNode (l+1))) c) ++ indent l ++ fTag l s
       fNode l (Content    c)             = c
       fNode l (ClosedNode t)             = fTag l t
       fTag  l (OpenTag    n a)           = "<" ++ n ++ (concat $ map (fAttr l) a) ++ ">"
       fTag  l (SluitTag   n)             = "</" ++ n ++ ">"
       fTag  l (ClosedTag n a)            = "<" ++ n ++ (concat $ map (fAttr l) a) ++ "/>"
       fAttr l (Attribute  n v q)         = " " ++ n ++ "=" ++ q ++ v ++ q
       indent l = "\n" ++ (concat $ replicate (4 * l) " ")